
#version 150

in  vec4 color;
in  vec2 texCoord;
in  float fog_factor;
out vec4 fColor;

uniform sampler2D tex;

void main() {
  if (texCoord.x > 10) { // cow
    fColor = vec4(0.1, 0.1, 0.1, 1);
  }
  else { // tex
    fColor = color * texture(tex, texCoord);
  }

  // fog
  vec4 fogColor = vec4(0.5, 0.5, 0.5, 1);
  fColor = fColor * fog_factor + fogColor * (1 - fog_factor);
} 
